Drupal.pp_ed_init = function () {
  $('#edit-body').each(function() {
    Drupal.pp_ed_attach_selector(this, 'edit-body');
    if (typeof(document.execCommand) != 'undefined') {
      if (Drupal.settings.pp_ed.pp_ed_default_mode == '0') {
        $('#tinymce_select').click();
      } else if (Drupal.settings.pp_ed.pp_ed_default_mode == '1') {
        $('#code_select').click();
      }
    }
  });
  if (Drupal.settings.pp_ed.pp_ed_edit_comments) {
    $('#edit-comment').each(function() {
      Drupal.pp_ed_attach_selector(this, 'edit-comment');
      if (typeof(document.execCommand) != 'undefined') {
        if (Drupal.settings.pp_ed.pp_ed_default_mode == '0') {
          $('#tinymce_select').click();
        } else if (Drupal.settings.pp_ed.pp_ed_default_mode == '1') {
          $('#code_select').click();
        }
      }
    });
  }
}

Drupal.pp_ed_attach_selector = function(elem, id) {
  if (typeof(document.execCommand) == 'undefined') {
    $(elem).after('<div style="font-size:x-small">' + Drupal.settings.pp_ed.no_wysiwyg_text + '</div>');
  }
  else {
    grippie = $(elem).siblings('.grippie');
    
    var tinymce_select = document.createElement('a');
    $(tinymce_select)
      .attr('id', 'tinymce_select')
      .css('cursor', 'pointer')
      .append('<span class="tab">' + Drupal.settings.pp_ed.tinymce_select_text + '</span>');

    var code_select = document.createElement('a');
    $(code_select)
      .attr('id', 'code_select')
      .css('cursor', 'pointer')
      .append('<span class="tab">' + Drupal.settings.pp_ed.code_select_text + '</span>');

    $(tinymce_select)
      .click(function() {
        Drupal.pp_ed_select(elem, 'tinymce');
        $(this).addClass('active').parent().addClass('active');
        $(code_select).removeClass('active').parent().removeClass('active');
        $(grippie).hide();
      });
    $(code_select)
      .click(function() {
        Drupal.pp_ed_select(elem, 'code');
        $(this).addClass('active').parent().addClass('active');
        $(tinymce_select).removeClass('active').parent().removeClass('active');
        $(grippie).show();
      });

    var div = document.createElement('div');
    var list = document.createElement('ul');
    var li1 = document.createElement('li');
    var li2 = document.createElement('li');

    $(list).attr('class', 'tabs primary')
      .append($(li1).append(tinymce_select))
      .append($(li2).append(code_select));
    $(div).attr('class', 'pp_ed_selector').css('margin-right', Drupal.pp_ed_selector_offset(id) + 'px').append(list);

    // $('label[for=edit-body]').before(div).addClass('clear-block');
    $('label[for=' + id + ']').before(div).addClass('clear-block');
  }
}

Drupal.pp_ed_selector_offset = function(id) {
  var label_width = $('label[for=' + id + ']').width();
  var edit_width = $('#' + id).width();

  result = /^([0-9]*)/.exec(label_width);
  if (result && result[1])
    label_width = result[1];

  result = /^([0-9]*)/.exec(edit_width);
  if (result && result[1])
    edit_width = result[1];

  return label_width - edit_width;
}

Drupal.pp_ed_select = function(elem, select) {
  if (select == 'tinymce') {
    $.post(Drupal.settings.basePath + '?q=pp_ed/pp_ed_default_mode', { 'pp_ed_default_mode' : 0 } );
    tinyMCE.execCommand('mceAddControl', true, elem.id);
  }
  else if (select == 'code') {
    $.post(Drupal.settings.basePath + '?q=pp_ed/pp_ed_default_mode', { 'pp_ed_default_mode' : 1 } );
    tinyMCE.execCommand('mceRemoveControl', true, elem.id);
  }
}

if (Drupal.jsEnabled) {
  tinymce.PluginManager.load('pp_ed_image', Drupal.settings.pp_ed.pp_ed_image_js);
  tinymce.PluginManager.load('break', Drupal.settings.pp_ed.break_js);
  tinymce.PluginManager.load('pp_ed_media', Drupal.settings.pp_ed.pp_ed_media_js);
  var config = {
    mode : "none", 
    theme : "advanced",
    theme_advanced_resizing : true,
    entity_encoding: "raw", 
    verify_html: true, 
    preformatted: false,            // default setting: false
    convert_fonts_to_spans: true,   // default setting: true
    remove_linebreaks: true,        // default setting: true
    apply_source_formatting: true,  // default setting: true
    relative_urls : false,           // default setting: true
    forced_root_block : '',
    document_base_url : Drupal.settings.basePath, 
    theme_advanced_resize_horizontal: false, 
    theme_advanced_resizing_use_cookie: false, 
    theme_advanced_toolbar_location: "top", 
    theme_advanced_toolbar_align: "left", 
    theme_advanced_path_location: "bottom", 
    theme_advanced_blockformats : "p,address,pre,h2,h3,h4,h5,h6", 
    plugins : "safari, paste, fullscreen, table, -pp_ed_image, -break, -pp_ed_media", 
    theme_advanced_buttons1 : 'bold, italic, underline, strikethrough, |, bullist, numlist, |, justifyleft, justifycenter, justifyright, justifyfull, |, link, unlink, |, break, pp_ed_image, pp_ed_image_delete , |, pp_ed_media, pp_ed_media_del', 
    theme_advanced_buttons2 : 'formatselect, forecolor, |, pastetext, pasteword, |, charmap, |, outdent, indent, blockquote, |, undo, redo, |, code, fullscreen', 
    theme_advanced_buttons3 : 'tablecontrols, visualaid', 
    custom_elements : 'pp_img, pp_media',
    extended_valid_elements : 'pp_img[type|title|caption|align|link|target|nid|preset|src|width|height|teaser],pp_media[type|title|caption|align|nid|width|height]',
    content_css : Drupal.settings.pp_ed.tinymce_content_css,
    skin: 'o2k7',
    skin_variant : "silver", 
    table_row_styles : "Odd=odd;Even=even"
  };  
  if (Drupal.settings.pp_ed.tinymce_popup_css != '')
    config.popup_css = Drupal.settings.pp_ed.tinymce_popup_css;
  if (Drupal.settings.pp_ed.tinymce_popup_css_add != '')
    config.popup_css_add = Drupal.settings.pp_ed.tinymce_popup_css_add;
  tinyMCE.init(config);  

  // Due to a conflict with ajax_view.js, we need to call this here directly. 
  Drupal.pp_ed_init();
}

/* To Add: blockquote, teaser break, page break, spelling, fullscreen?, remove formatting, embedded media

 * 
 */
