<?php

class pp_views_handler_field_story_edition_ref_multiple extends views_handler_field_node {
  function query() {
    // Override the parent and intentionally do nothing
  }
  
  function pre_render($values) {
    if (isset($this->view->build_info['summary']) || empty($values)) {
      return parent::pre_render($values);
    }

    $this->field_values = array();
    $nids = array();
    foreach ($values as $value) {
      $nid = $value->{$this->additional_fields['nid']};
      $nids[] = $nid;
      $this->field_values[$nid] = array();
    }

    $query = "SELECT node.nid AS parent_nid, node_node_references.nid AS other_nid, node_node_references.title AS other_title, node_node_content_type_edition.field_eid_value AS other_eid ".
             " FROM {node} node".
             " LEFT JOIN {node_references} node_references ON node.nid = node_references.nid".
             " LEFT JOIN {node} node_node_references ON node_node_references.nid = node_references.other_nid".
             " LEFT JOIN {content_type_edition} node_node_content_type_edition ON node_node_content_type_edition.vid = node_node_references.vid".
             " WHERE node.nid IN (". implode(',', $nids) .")".
             " ORDER BY other_nid ASC";
    $result = db_query($query);

    while ($item = db_fetch_array($result)) {
      $this->field_values[$item['parent_nid']][] = $item;
    }
  }

  function render($values) {
    $items = array();
    foreach ($this->field_values[$values->{$this->additional_fields['nid']}] as $item) {
      $value = $item;
      if (!empty($value)) {
        $items[] = $this->render_link($value, $values);
      }
    }
    
    if (count($items) == 1) {
      return $items[0];
    }
    else if (count($items)) {
      return theme('story_edition_reference_list', $items);
    }
  }
  
  function render_link($data, $values) {
    return theme('edition_link', check_plain($data['other_title']), check_plain($data['other_eid']),
                !empty($this->options['link_to_node']) ? ("node/" . $data['other_nid']) : '');
  }
}
